using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.IO.Ports;
using System.IO;

namespace EG01010
{
    public partial class Form1 : Form
    {
        private delegate void displayDeleg(int wave);
        private delegate void nextPulseDeleg(int pulse);
        private delegate void nextRespDeleg(int Resp);
        private delegate void nextstatusDeleg(int status);


        //EKG ekg = null;
        bool startbyte = false;
        bool tone = false;
        bool Resp_flag = false;
        bool Puls_flag = false;
        bool status_flag = false;
        
        byte[] buffer ={ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 };
        //byte buf = 0;
       


        public Form1()
        {
            InitializeComponent();
            //ekg = new EKG(this);
            list_comport();
            bmp = new Bitmap(pictureBox1.Width, pictureBox1.Height);
            g = Graphics.FromImage(bmp);
            g.Clear(Color.White);
            pictureBox1.Image = bmp;
            
        }

        // search all Comports 
        private void list_comport()
        {
            {
                // Get a list of serial port names. 
                string[] ports = SerialPort.GetPortNames();

                portToolStripMenuItem.DropDownItems.Clear();
                portToolStripMenuItem.DropDownItems.Add("Update...", null, new EventHandler(updateToolStripMenuItem_Click));
                // Display each port name to the console. 
                foreach (string port in ports)
                {

                    portToolStripMenuItem.DropDownItems.Add(port, null, new EventHandler(port_Click));
                }
            }
        }

        private void updateToolStripMenuItem_Click(object sender, EventArgs e)
        {
            list_comport();
            foreach (ToolStripMenuItem item in portToolStripMenuItem.DropDownItems)
            {
                if (item.Text == toolStripStatusLabel_Port.Text)
                {
                    item.Checked = true;
                }
            }
        }

        // open Comport
        private void port_Click(object sender, EventArgs e)
        {
            if (serialPort1.IsOpen)
                serialPort1.DiscardInBuffer();
            serialPort1.Close();

            if (((ToolStripMenuItem)sender).Checked == false)
            {
                foreach (ToolStripMenuItem item in portToolStripMenuItem.DropDownItems)
                {
                    item.Checked = false;
                }
                string Port = sender.ToString();
                // ((ToolStripMenuItem)sender).Checked = true;
                serialPort1.PortName = Port;
                try
                {
                    serialPort1.Open();

                }
                catch
                {
                    MessageBox.Show("Serial port " + serialPort1.PortName +
                            " cannot be opened!", "RS232 tester",
                            MessageBoxButtons.OK, MessageBoxIcon.Warning);
                }
                if (serialPort1.IsOpen)
                {
                    ((ToolStripMenuItem)sender).Checked = true;
                    toolStripStatusLabel_Port.Text = Port;
                    timer2.Start();
                }
            }
            else
            {
                ((ToolStripMenuItem)sender).Checked = false;
                toolStripStatusLabel_Port.Text = "No Port...";
            }


            if (serialPort1.IsOpen)
            {
                //serialPort1.WriteLine("I");


                radioButton_Amp1.PerformClick();
                radioButton_100.PerformClick();
                radioButton_normal.PerformClick();
                radioButton_Monitor.PerformClick();
                radioButton_paceOn.PerformClick();
                radioButton_50Hz.PerformClick();
                radioButton_II.PerformClick();
            }

        }

        // parse serial Data
        private void serialPort1_DataReceived(object sender, System.IO.Ports.SerialDataReceivedEventArgs e)
        {
            
            while (serialPort1.BytesToRead > 4)
            {

                byte buf = 0; 
                buf = Convert.ToByte(serialPort1.ReadByte());
                if ((startbyte == true) && buf > 0xF7)
                {
                    startbyte = false;
                }

                if (buf > 0xf7 && startbyte == false)
                {
                    //startbyte = true;
                    if (buf == 0xf8)
                    {
                        startbyte = true;
                    }

                    if (buf > 0xf8)
                    {
                        byte RX = buf;
                        buf = Convert.ToByte(serialPort1.ReadByte());

                        if (RX == 0xf9) // Resp. value
                        {
                            //SPO = buf;
                            this.BeginInvoke(new nextRespDeleg(nextResp), new object[] { buf });
                        }

                        else if (RX == 0xfa) // Pulse Value
                        {
                            //Pulse = buf;
                            this.BeginInvoke(new nextPulseDeleg(nextPulse), new object[] { buf });
                        }
                        else if (RX == 0xfb)
                        {
                            //Status = buf;  // Info message
                            this.BeginInvoke(new nextstatusDeleg(nextstatus), new object[] { buf });
                        }


                    }

                }
                else if (startbyte == true)
                {
                    int wavepoint = 0;
                    //if (serialPort1.BytesToRead>2)
                    wavepoint = Convert.ToInt16(buf);
                    this.BeginInvoke(new displayDeleg(Display), new object[] { wavepoint });
                }
                else { }
            }
        }

        private void nextPulse(int pulse)
        {
           // timer3.Stop();
            Puls_flag = true;
            int frq;
            //int SpO2 = Convert.ToInt16(label_SpO2.Text);
            label_Pulse.Text = Convert.ToString(pulse);
            //if ((tone == true) && (pulse <= 100) && (SpO2 <= 100))     // Have to beep ?
            if (tone == true)
            {
                //if (SpO2 > 80)                                              // V1.51
                //{
                //    frq = SpO2 - 80;
                //}
                //else
                {
                    frq = 0;
                }

                Piep(pt[frq], 50);
            }
            //timer3.Start();
        }

        private void nextResp(int Resp)
        {
           // timer3.Stop();
            Resp_flag = true;
            label_Resp.Text = Convert.ToString(Resp);
           // timer3.Start();
        }

        //  81   82   83   84   85   86   87   88   89   90   91   92   93   94   95   96    97    98    99    100
        int[] pt = { 440, 466, 494, 523, 554, 587, 622, 659, 698, 740, 784, 831, 880, 932, 988, 1046, 1109, 1175, 1244, 1328 };

        private void Piep(double Frequenz, int time)
        {
            const int MinFreq = 0x25;
            const int MaxFreq = 0x7FFF;
            //const int IntFreq  = 1193180;




            if (Frequenz < MinFreq)
                Frequenz = MinFreq;
            else if (Frequenz > MaxFreq)
                Frequenz = MaxFreq;

            Console.Beep((int)(Frequenz), time);

        }


        private void Display(int wave)
        {

            
            if (Status != 0)
            {
                wave = 128;
            }
            //double factor = pictureBox1.Height / 256.0;
            //bar1.Value = wave;

            if (index < pictureBox1.Width)
            {
                index = index + 2;
            }
            else
            {
                index = 0;
            }

            wave = (256 - wave) ;

            g.DrawLine(new Pen(Color.White, 2), index, 0, index, pictureBox1.Height);
            g.DrawLine(new Pen(Color.White, 2), index + 1, 0, index + 1, pictureBox1.Height);

            if (index >= 1)
            {
                g.DrawLine(new Pen(Color.Blue, 1), index - 2, old_wave, index, wave);

            }

            old_wave = wave;

            if (outfileCtr > 0)
            {
                foreach (RadioButton Member in groupBox3.Controls)
                {
                    if (((RadioButton)Member).Checked == true)
                    {
                        outfile.Write(((RadioButton)Member).Text);
                        outfile.Write("\t");
                    }
                }
                outfile.Write(wave);
                outfile.Write("\t");
                outfile.Write(label_Pulse.Text);
                outfile.Write("\t");
                outfile.Write(label_Pulse.Text);
                outfile.Write("\t");
                outfile.WriteLine(toolStripStatusLabel_time.Text);
                //outfile.Write("\t");

            }
            



        }

        int index = 0;
        int old_wave = 0;
        Graphics g;
        Bitmap bmp;
        int Status = 0;

        private void nextstatus(int status)
        {
            status_flag = true;
            Status = status;
            if (status == 0x11) 
            label_Status.Text = "LEAD OFF";
        }

        // simulate / Normal-mode
        private void Mode_Checked(object sender, EventArgs e)
        {
            if (((RadioButton)sender).Text == "Normal")
            {
                if (serialPort1.IsOpen)
                    serialPort1.WriteLine("N");
            }
            if (((RadioButton)sender).Text == "Simulate")
            {
                if (serialPort1.IsOpen)
                    serialPort1.WriteLine("M");
            }
        }

        //en- / disable Pacemakerdetection
        private void Pace_Checked(object sender, EventArgs e)
        {
            if (((RadioButton)sender).Text == "On")
            {
                if (serialPort1.IsOpen)
                    serialPort1.WriteLine("P1");
            }
            if (((RadioButton)sender).Text == "Off")
            {
                if (serialPort1.IsOpen)
                    serialPort1.WriteLine("P0");
            }
        }

        // en- / disable Pacemakerdetection
        private void Bandwidth_Checked(object sender, EventArgs e)
        {
            if (((RadioButton)sender).Text == "Diag.")
            {
                if (serialPort1.IsOpen)
                    serialPort1.WriteLine("F0");
            }
            if (((RadioButton)sender).Text == "Monitor")
            {
                if (serialPort1.IsOpen)
                    serialPort1.WriteLine("F1");
            }
        }

        // Amplitude if the signal
        private void Amplitute_Checked(object sender, EventArgs e)
        {
            if (((RadioButton)sender).Text == "Amp 1")
            {
                //Max_Wert = 8;
                if (serialPort1.IsOpen)
                {
                    serialPort1.WriteLine("A0");

                }
            }
            if (((RadioButton)sender).Text == "Amp 2")
            {
                //Max_Wert = 4;
                if (serialPort1.IsOpen)
                {
                    serialPort1.WriteLine("A1");
                }
            }
            if (((RadioButton)sender).Text == "Amp 3")
            {
                //Max_Wert = 2;
                if (serialPort1.IsOpen)
                {
                    serialPort1.WriteLine("A2");
                }
            }
            
            toolStripStatusLabel_Amplitude.Text = ((RadioButton)sender).Text;
        }

        // 50Hz / 60Hz filter
        private void Filter_Checked(object sender, EventArgs e)
        {
            if (((RadioButton)sender).Text == "50 Hz")
            {
                if (serialPort1.IsOpen)
                    serialPort1.WriteLine("5");
            }
            if (((RadioButton)sender).Text == "60 Hz")
            {
                if (serialPort1.IsOpen)
                    serialPort1.WriteLine("6");
            }
            
        }

        // Speed of the Graph
        private void Speed_Checked(object sender, EventArgs e)
        {
            if (((RadioButton)sender).Text == "50/sec")
            {
                if (serialPort1.IsOpen)
                    serialPort1.WriteLine("S2");

            }
            if (((RadioButton)sender).Text == "100/sec")
            {
                if (serialPort1.IsOpen)
                    serialPort1.WriteLine("S1");
            }
           

            if (((RadioButton)sender).Text == "300/sec")
            {
                if (serialPort1.IsOpen)
                    serialPort1.WriteLine("S0");
            }
            toolStripStatusLabel_Speed.Text = ((RadioButton)sender).Text;
        }
        
        private void Channel_Checked(object sender, EventArgs e)
        {
            if (((RadioButton)sender).Text == "I")
            {
                if (serialPort1.IsOpen)
                    serialPort1.WriteLine("G2");

            }
            if (((RadioButton)sender).Text == "II")
            {
                if (serialPort1.IsOpen)
                    serialPort1.WriteLine("G1");
            }
            if (((RadioButton)sender).Text == "III")
            {
                if (serialPort1.IsOpen)
                    serialPort1.WriteLine("G0");
            }
        }
        
        private void Curve_Checked(object sender, EventArgs e)
        {
            if (((RadioButton)sender).Text == "EKG")
            {
                if (serialPort1.IsOpen)
                    serialPort1.WriteLine("D0");

            }
            if (((RadioButton)sender).Text == "Resp.")
            {
                if (serialPort1.IsOpen)
                    serialPort1.WriteLine("D1");
            }
        }

        private void Form1_Leave(object sender, EventArgs e)
        {
            if (serialPort1.IsOpen)
                serialPort1.Close();
            if (outfileCtr > 0)
                outfile.Close();

        }

        // update time in the statusbar
        private void timer1_Tick(object sender, EventArgs e)
        {
            toolStripStatusLabel_time.Text = DateTime.Now.ToLongTimeString();
        }

        string File;

        //Dialogbox for Savefile
        private void openToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (serialPort1.IsOpen)
            {
                SaveFileDialog dialog = new SaveFileDialog();
                dialog.Filter = "Log files (*.log)|*.log|txt files (*.txt)|*.txt|All files (*.*)|*.*";
                dialog.Title = "Select a file";
                //dialog.ShowDialog();


                if (dialog.ShowDialog() == DialogResult.OK)
                {
                    File = dialog.FileName;
                    

                    toolStripStatusLabel1.Text = dialog.FileName;
                }

            }
            else
            {
                MessageBox.Show("Please select Com-Port first", "Open Dialog",
                          MessageBoxButtons.OK, MessageBoxIcon.Warning);


            }
        }

        // en- / disable pulseton
        private void onToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (onToolStripMenuItem.Checked == true)
                onToolStripMenuItem.Checked = false;
            else if (onToolStripMenuItem.Checked == false)
                onToolStripMenuItem.Checked = true;
            tone = onToolStripMenuItem.Checked;

        }
        
        StreamWriter outfile;
        int outfileCtr=0;

        // en- / disable Datasaving 
        private void SaveToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if ((((ToolStripMenuItem)sender).Text == "okay")&&(((ToolStripMenuItem)sender).Checked == false))
            {
                if (outfile == null)
                {
                    if (File != null)
                    {
                        outfile = new StreamWriter(File);
                        //outfileCtr = 1;
                    }
                }

                if (outfile != null)
                {
                    okayToolStripMenuItem.Checked = true;
                    outfileCtr = 1;
                    
                    
                    outfile.WriteLine("EG01010");
                    outfile.WriteLine("\"Ch\"\t\"Wave\"\t\"Pulse\"\t\"Resp\"\t\"Time\"");
                    


                }
            }
            else if (((ToolStripMenuItem)sender).Text == "abort")
            {
                okayToolStripMenuItem.Checked = false;
                
                outfileCtr = 0;
                outfile.Close();
                outfile = null;
            }
        }
        // Timer update Graph
        private void timer2_Tick(object sender, EventArgs e)
        {
            //this.BeginInvoke(new nextUpdateDeleg(update), new object[] { });
            pictureBox1.Refresh();
        }


        private void aboutToolStripMenuItem_Click(object sender, EventArgs e)
        {
            AboutBox1 frm = new AboutBox1();
            frm.Show();
        }

        private void Form1_FormClosed(object sender, FormClosedEventArgs e)
        {
            exitToolStripMenuItem.PerformClick();
        }

        private void timer3_Tick(object sender, EventArgs e)
        {
            if (Resp_flag == false)
            {
                label_Resp.Text = "";
            }
            if (Puls_flag == false)
            {
                label_Pulse.Text = "";
            }
            if (status_flag == false)
            {
                label_Status.Text = "";
                Status = 0;
            }
            Resp_flag = false;
            Puls_flag = false;
            status_flag = false;
        }

        private void button_Calibrate_Click(object sender, EventArgs e)
        {
            if (serialPort1.IsOpen)
                serialPort1.WriteLine("C");
        }

    }
}
